import { CodeMirrorLSPFeature, CommandEntryPoint } from '../feature';
export class CodeAction extends CodeMirrorLSPFeature {
    register() {
        this.connection_handlers.set('codeActionsProvided', this.handleCodeActions.bind(this));
        super.register();
    }
    handleCodeActions(actions) {
        console.warn(actions);
    }
    handleCommand(workspaceEdit) {
        this.apply_edit(workspaceEdit);
    }
}
CodeAction.commands = [
    {
        id: 'code-action',
        execute: ({ connection, virtual_position, document }) => {
            connection.getCodeActions(virtual_position, []);
        },
        is_enabled: ({ connection }) => connection.isCodeActionSupported(),
        label: 'Quick fix/code action',
        attach_to: new Set([
            // notebooks are not supported yet
            CommandEntryPoint.FileEditorContextMenu
        ])
    }
];
//# sourceMappingURL=code_action.js.map