import { JupyterLabWidgetAdapter } from './jl_adapter';
import { FileEditor } from '@jupyterlab/fileeditor';
import { IDocumentWidget } from '@jupyterlab/docregistry';
import { FileEditorJumper } from '@krassowski/jupyterlab_go_to_definition/lib/jumpers/fileeditor';
import * as CodeMirror from 'codemirror';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { CodeMirrorEditor } from '@jupyterlab/codemirror';
import { ICompletionManager } from '@jupyterlab/completer';
import { LSPConnector } from './components/completion';
import { CodeEditor } from '@jupyterlab/codeeditor';
import { VirtualFileEditor } from '../../virtual/editors/file_editor';
import { DocumentConnectionManager } from '../../connection_manager';
export declare class FileEditorAdapter extends JupyterLabWidgetAdapter {
    protected completion_manager: ICompletionManager;
    editor: FileEditor;
    jumper: FileEditorJumper;
    virtual_editor: VirtualFileEditor;
    protected current_completion_connector: LSPConnector;
    get document_path(): string;
    get mime_type(): string;
    get language_file_extension(): string;
    get ce_editor(): CodeMirrorEditor;
    get cm_editor(): CodeMirror.Editor;
    find_ce_editor(cm_editor: CodeMirror.Editor): CodeEditor.IEditor;
    constructor(editor_widget: IDocumentWidget<FileEditor>, jumper: FileEditorJumper, app: JupyterFrontEnd, completion_manager: ICompletionManager, rendermime_registry: IRenderMimeRegistry, connection_manager: DocumentConnectionManager);
    connect_completion(): void;
    get path(): string;
}
