import { JupyterLabWidgetAdapter } from './jl_adapter';
import { Notebook, NotebookPanel } from '@jupyterlab/notebook';
import * as CodeMirror from 'codemirror';
import { VirtualEditorForNotebook } from '../../virtual/editors/notebook';
import { ICompletionManager } from '@jupyterlab/completer';
import { NotebookJumper } from '@krassowski/jupyterlab_go_to_definition/lib/jumpers/notebook';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { LSPConnector } from './components/completion';
import { CodeEditor } from '@jupyterlab/codeeditor';
import { Cell } from '@jupyterlab/cells';
import { nbformat } from '@jupyterlab/coreutils';
import ILanguageInfoMetadata = nbformat.ILanguageInfoMetadata;
import { DocumentConnectionManager } from '../../connection_manager';
import { IClientSession } from '@jupyterlab/apputils';
import { Session } from '@jupyterlab/services';
export declare class NotebookAdapter extends JupyterLabWidgetAdapter {
    editor: Notebook;
    widget: NotebookPanel;
    virtual_editor: VirtualEditorForNotebook;
    completion_manager: ICompletionManager;
    jumper: NotebookJumper;
    protected current_completion_connector: LSPConnector;
    constructor(editor_widget: NotebookPanel, jumper: NotebookJumper, app: JupyterFrontEnd, completion_manager: ICompletionManager, rendermime_registry: IRenderMimeRegistry, connection_manager: DocumentConnectionManager);
    on_kernel_changed(_session: IClientSession, change: Session.IKernelChangedArgs): void;
    dispose(): void;
    is_ready: () => boolean;
    get document_path(): string;
    protected language_info(): ILanguageInfoMetadata;
    get mime_type(): string;
    get language_file_extension(): string;
    find_ce_editor(cm_editor: CodeMirror.Editor): CodeEditor.IEditor;
    init_once_ready(): Promise<void>;
    private set_completion_connector;
    current_completion_handler: ICompletionManager.ICompletableAttributes;
    connect_completion(): void;
    on_completions(notebook: Notebook, cell: Cell): void;
}
