import * as CodeMirror from 'codemirror';
import { CodeEditor } from '@jupyterlab/codeeditor';
/**
 * is_* attributes are there only to enforce strict interface type checking
 */
export interface IPosition extends CodeMirror.Position {
}
export declare function is_equal(self: IPosition, other: IPosition): boolean;
export interface ISourcePosition extends IPosition {
    is_source: true;
}
export interface IEditorPosition extends IPosition {
    is_editor: true;
}
export interface IVirtualPosition extends IPosition {
    is_virtual: true;
}
export interface IRootPosition extends ISourcePosition {
    is_root: true;
}
export declare function position_at_offset(offset: number, lines: string[]): CodeEditor.IPosition;
export declare function offset_at_position(position: CodeEditor.IPosition, lines: string[], lines_include_breaks?: boolean): number;
